# Data Sources

## List Pipeline Data Sources

`IReadOnlyList<PipelineDataSource> Pipelines.DataSources.GetDataSources(DataSourceGetDataSourcesParamsparameters, CancellationTokencancellationToken = default)`

**get** `/api/v1/pipelines/{pipeline_id}/data-sources`

Get data sources for a pipeline.

### Parameters

- `DataSourceGetDataSourcesParams parameters`

  - `required string pipelineID`

### Example

```csharp
DataSourceGetDataSourcesParams parameters = new()
{
    PipelineID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
};

var pipelineDataSources = await client.Pipelines.DataSources.GetDataSources(parameters);

Console.WriteLine(pipelineDataSources);
```

#### Response

```json
[
  {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "component": {
      "foo": "bar"
    },
    "data_source_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "last_synced_at": "2019-12-27T18:11:19.117Z",
    "name": "name",
    "pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "source_type": "AZURE_STORAGE_BLOB",
    "created_at": "2019-12-27T18:11:19.117Z",
    "custom_metadata": {
      "foo": {
        "foo": "bar"
      }
    },
    "status": "CANCELLED",
    "status_updated_at": "2019-12-27T18:11:19.117Z",
    "sync_interval": 0,
    "sync_schedule_set_by": "sync_schedule_set_by",
    "updated_at": "2019-12-27T18:11:19.117Z",
    "version_metadata": {
      "reader_version": "1.0"
    }
  }
]
```

## Add Data Sources To Pipeline

`IReadOnlyList<PipelineDataSource> Pipelines.DataSources.UpdateDataSources(DataSourceUpdateDataSourcesParamsparameters, CancellationTokencancellationToken = default)`

**put** `/api/v1/pipelines/{pipeline_id}/data-sources`

Add data sources to a pipeline.

### Parameters

- `DataSourceUpdateDataSourcesParams parameters`

  - `required string pipelineID`

  - `required IReadOnlyList<Body> body`

    - `required string DataSourceID`

      The ID of the data source.

    - `Double? SyncInterval`

      The interval at which the data source should be synced. Valid values are: 21600, 43200, 86400

### Example

```csharp
DataSourceUpdateDataSourcesParams parameters = new()
{
    PipelineID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    Body =
    [
        new()
        {
            DataSourceID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
            SyncInterval = 0,
        },
    ],
};

var pipelineDataSources = await client.Pipelines.DataSources.UpdateDataSources(parameters);

Console.WriteLine(pipelineDataSources);
```

#### Response

```json
[
  {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "component": {
      "foo": "bar"
    },
    "data_source_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "last_synced_at": "2019-12-27T18:11:19.117Z",
    "name": "name",
    "pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "source_type": "AZURE_STORAGE_BLOB",
    "created_at": "2019-12-27T18:11:19.117Z",
    "custom_metadata": {
      "foo": {
        "foo": "bar"
      }
    },
    "status": "CANCELLED",
    "status_updated_at": "2019-12-27T18:11:19.117Z",
    "sync_interval": 0,
    "sync_schedule_set_by": "sync_schedule_set_by",
    "updated_at": "2019-12-27T18:11:19.117Z",
    "version_metadata": {
      "reader_version": "1.0"
    }
  }
]
```

## Update Pipeline Data Source

`PipelineDataSource Pipelines.DataSources.Update(DataSourceUpdateParamsparameters, CancellationTokencancellationToken = default)`

**put** `/api/v1/pipelines/{pipeline_id}/data-sources/{data_source_id}`

Update the configuration of a data source in a pipeline.

### Parameters

- `DataSourceUpdateParams parameters`

  - `required string pipelineID`

    Path param

  - `required string dataSourceID`

    Path param

  - `Double? syncInterval`

    Body param: The interval at which the data source should be synced.

### Returns

- `class PipelineDataSource:`

  Schema for a data source in a pipeline.

  - `required string ID`

    Unique identifier

  - `required Component Component`

    Component that implements the data source

    - `IReadOnlyDictionary<string, JsonElement>`

    - `class CloudS3DataSource:`

      - `required string Bucket`

        The name of the S3 bucket to read from.

      - `string? AwsAccessID`

        The AWS access ID to use for authentication.

      - `string? AwsAccessSecret`

        The AWS access secret to use for authentication.

      - `string ClassName`

      - `string? Prefix`

        The prefix of the S3 objects to read from.

      - `string? RegexPattern`

        The regex pattern to filter S3 objects. Must be a valid regex pattern.

      - `string? S3EndpointUrl`

        The S3 endpoint URL to use for authentication.

      - `Boolean SupportsAccessControl`

    - `class CloudAzStorageBlobDataSource:`

      - `required string AccountUrl`

        The Azure Storage Blob account URL to use for authentication.

      - `required string ContainerName`

        The name of the Azure Storage Blob container to read from.

      - `string? AccountKey`

        The Azure Storage Blob account key to use for authentication.

      - `string? AccountName`

        The Azure Storage Blob account name to use for authentication.

      - `string? Blob`

        The blob name to read from.

      - `string ClassName`

      - `string? ClientID`

        The Azure AD client ID to use for authentication.

      - `string? ClientSecret`

        The Azure AD client secret to use for authentication.

      - `string? Prefix`

        The prefix of the Azure Storage Blob objects to read from.

      - `Boolean SupportsAccessControl`

      - `string? TenantID`

        The Azure AD tenant ID to use for authentication.

    - `class CloudGoogleDriveDataSource:`

      - `required string FolderID`

        The ID of the Google Drive folder to read from.

      - `string ClassName`

      - `string? FolderName`

        Human-readable name of the selected folder, for display.

      - `IReadOnlyDictionary<string, string>? ServiceAccountKey`

        A dictionary containing secret values

      - `Boolean SupportsAccessControl`

    - `class CloudOneDriveDataSource:`

      - `required string ClientID`

        The client ID to use for authentication.

      - `required string ClientSecret`

        The client secret to use for authentication.

      - `required string TenantID`

        The tenant ID to use for authentication.

      - `required string UserPrincipalName`

        The user principal name to use for authentication.

      - `string ClassName`

      - `string? FolderID`

        The ID of the OneDrive folder to read from.

      - `string? FolderPath`

        The path of the OneDrive folder to read from.

      - `IReadOnlyList<string>? RequiredExts`

        The list of required file extensions.

      - `SupportsAccessControl SupportsAccessControl`

        - `trueTrue`

    - `class CloudSharepointDataSource:`

      - `required string ClientID`

        The client ID to use for authentication.

      - `required string ClientSecret`

        The client secret to use for authentication.

      - `required string TenantID`

        The tenant ID to use for authentication.

      - `string ClassName`

      - `string? DriveName`

        The name of the Sharepoint drive to read from.

      - `IReadOnlyList<string>? ExcludePathPatterns`

        List of regex patterns for file paths to exclude. Files whose paths (including filename) match any pattern will be excluded. Example: ['/temp/', '/backup/', '.git/', '.tmp$', '^~']

      - `string? FolderID`

        The ID of the Sharepoint folder to read from.

      - `string? FolderPath`

        The path of the Sharepoint folder to read from.

      - `Boolean GetPermissions`

        Whether to get permissions for the sharepoint site.

      - `IReadOnlyList<string>? IncludePathPatterns`

        List of regex patterns for file paths to include. Full paths (including filename) must match at least one pattern to be included. Example: ['/reports/', '/docs/.*.pdf$', '^Report.*.pdf$']

      - `IReadOnlyList<string>? RequiredExts`

        The list of required file extensions.

      - `string? SiteID`

        The ID of the SharePoint site to download from.

      - `string? SiteName`

        The name of the SharePoint site to download from.

      - `SupportsAccessControl SupportsAccessControl`

        - `trueTrue`

    - `class CloudSlackDataSource:`

      - `required string SlackToken`

        Slack Bot Token.

      - `string? ChannelIds`

        Slack Channel.

      - `string? ChannelPatterns`

        Slack Channel name pattern.

      - `string ClassName`

      - `string? EarliestDate`

        Earliest date.

      - `Double? EarliestDateTimestamp`

        Earliest date timestamp.

      - `string? LatestDate`

        Latest date.

      - `Double? LatestDateTimestamp`

        Latest date timestamp.

      - `Boolean SupportsAccessControl`

    - `class CloudNotionPageDataSource:`

      - `required string IntegrationToken`

        The integration token to use for authentication.

      - `string ClassName`

      - `string? DatabaseIds`

        The Notion Database Id to read content from.

      - `string? PageIds`

        The Page ID's of the Notion to read from.

      - `Boolean SupportsAccessControl`

    - `class CloudConfluenceDataSource:`

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Confluence APIs.

      - `required string ServerUrl`

        The server URL of the Confluence instance.

      - `string? ApiToken`

        The API token to use for authentication.

      - `string ClassName`

      - `string? Cql`

        The CQL query to use for fetching pages.

      - `FailureHandlingConfig FailureHandling`

        Configuration for handling failures during processing. Key-value object controlling failure handling behaviors.

        Example:
        {
        "skip_list_failures": true
        }

        Currently supports:

        - skip_list_failures: Skip failed batches/lists and continue processing

        - `Boolean SkipListFailures`

          Whether to skip failed batches/lists and continue processing

      - `Boolean IndexRestrictedPages`

        Whether to index restricted pages.

      - `Boolean KeepMarkdownFormat`

        Whether to keep the markdown format.

      - `string? Label`

        The label to use for fetching pages.

      - `string? PageIds`

        The page IDs of the Confluence to read from.

      - `string? SpaceKey`

        The space key to read from.

      - `Boolean SupportsAccessControl`

      - `Boolean SyncPermissions`

        Whether to fetch space-level permissions (allowed users/groups) and attach them to document metadata for access control. Disable for Confluence Server/Data Center versions whose permission APIs are unavailable (e.g. the JSON-RPC API removed in Data Center 9.2.6+), which otherwise surface as 401 errors during sync.

      - `string? UserName`

        The username to use for authentication.

    - `class CloudJiraDataSource:`

      Cloud Jira Data Source integrating JiraReader.

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Jira APIs.

      - `required string Query`

        JQL (Jira Query Language) query to search.

      - `string? ApiToken`

        The API/ Access Token used for Basic, PAT and OAuth2 authentication.

      - `string ClassName`

      - `string? CloudID`

        The cloud ID, used in case of OAuth2.

      - `string? Email`

        The email address to use for authentication.

      - `string? ServerUrl`

        The server url for Jira Cloud.

      - `Boolean SupportsAccessControl`

    - `class CloudJiraDataSourceV2:`

      Cloud Jira Data Source integrating JiraReaderV2.

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Jira APIs.

      - `required string Query`

        JQL (Jira Query Language) query to search.

      - `required string ServerUrl`

        The server url for Jira Cloud.

      - `string? ApiToken`

        The API Access Token used for Basic, PAT and OAuth2 authentication.

      - `ApiVersion ApiVersion`

        Jira REST API version to use (2 or 3). 3 supports Atlassian Document Format (ADF).

        - `"2"2`

        - `"3"3`

      - `string ClassName`

      - `string? CloudID`

        The cloud ID, used in case of OAuth2.

      - `string? Email`

        The email address to use for authentication.

      - `string? Expand`

        Fields to expand in the response.

      - `IReadOnlyList<string>? Fields`

        List of fields to retrieve from Jira. If None, retrieves all fields.

      - `Boolean GetPermissions`

        Whether to fetch project role permissions and issue-level security

      - `Long? RequestsPerMinute`

        Rate limit for Jira API requests per minute.

      - `Boolean SupportsAccessControl`

    - `class CloudBoxDataSource:`

      - `required AuthenticationMechanism AuthenticationMechanism`

        The type of authentication to use (Developer Token or CCG)

        - `"ccg"Ccg`

        - `"developer_token"DeveloperToken`

      - `string ClassName`

      - `string? ClientID`

        Box API key used for identifying the application the user is authenticating with

      - `string? ClientSecret`

        Box API secret used for making auth requests.

      - `string? DeveloperToken`

        Developer token for authentication if authentication_mechanism is 'developer_token'.

      - `string? EnterpriseID`

        Box Enterprise ID, if provided authenticates as service.

      - `string? FolderID`

        The ID of the Box folder to read from.

      - `Boolean SupportsAccessControl`

      - `string? UserID`

        Box User ID, if provided authenticates as user.

  - `required string DataSourceID`

    The ID of the data source.

  - `required DateTimeOffset LastSyncedAt`

    The last time the data source was automatically synced.

  - `required string Name`

    The name of the data source.

  - `required string PipelineID`

    The ID of the pipeline.

  - `required string ProjectID`

  - `required SourceType SourceType`

    - `"AZURE_STORAGE_BLOB"AzureStorageBlob`

    - `"BOX"Box`

    - `"CONFLUENCE"Confluence`

    - `"GOOGLE_DRIVE"GoogleDrive`

    - `"JIRA"Jira`

    - `"JIRA_V2"JiraV2`

    - `"MICROSOFT_ONEDRIVE"MicrosoftOnedrive`

    - `"MICROSOFT_SHAREPOINT"MicrosoftSharepoint`

    - `"NOTION_PAGE"NotionPage`

    - `"S3"S3`

    - `"SLACK"Slack`

  - `DateTimeOffset? CreatedAt`

    Creation datetime

  - `IReadOnlyDictionary<string, CustomMetadata?>? CustomMetadata`

    Custom metadata that will be present on all data loaded from the data source

    - `IReadOnlyDictionary<string, JsonElement>`

    - `IReadOnlyList<JsonElement>`

    - `string`

    - `Double`

    - `Boolean`

  - `Status? Status`

    The status of the data source in the pipeline.

    - `"CANCELLED"Cancelled`

    - `"ERROR"Error`

    - `"IN_PROGRESS"InProgress`

    - `"NOT_STARTED"NotStarted`

    - `"SUCCESS"Success`

  - `DateTimeOffset? StatusUpdatedAt`

    The last time the status was updated.

  - `Double? SyncInterval`

    The interval at which the data source should be synced.

  - `string? SyncScheduleSetBy`

    The id of the user who set the sync schedule.

  - `DateTimeOffset? UpdatedAt`

    Update datetime

  - `DataSourceReaderVersionMetadata? VersionMetadata`

    Version metadata for the data source

    - `ReaderVersion? ReaderVersion`

      The version of the reader to use for this data source.

      - `"1.0"1_0`

      - `"2.0"2_0`

      - `"2.1"2_1`

### Example

```csharp
DataSourceUpdateParams parameters = new()
{
    PipelineID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    DataSourceID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
};

var pipelineDataSource = await client.Pipelines.DataSources.Update(parameters);

Console.WriteLine(pipelineDataSource);
```

#### Response

```json
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "component": {
    "foo": "bar"
  },
  "data_source_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "last_synced_at": "2019-12-27T18:11:19.117Z",
  "name": "name",
  "pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "source_type": "AZURE_STORAGE_BLOB",
  "created_at": "2019-12-27T18:11:19.117Z",
  "custom_metadata": {
    "foo": {
      "foo": "bar"
    }
  },
  "status": "CANCELLED",
  "status_updated_at": "2019-12-27T18:11:19.117Z",
  "sync_interval": 0,
  "sync_schedule_set_by": "sync_schedule_set_by",
  "updated_at": "2019-12-27T18:11:19.117Z",
  "version_metadata": {
    "reader_version": "1.0"
  }
}
```

## Get Pipeline Data Source Status

`ManagedIngestionStatusResponse Pipelines.DataSources.GetStatus(DataSourceGetStatusParamsparameters, CancellationTokencancellationToken = default)`

**get** `/api/v1/pipelines/{pipeline_id}/data-sources/{data_source_id}/status`

Get the status of a data source for a pipeline.

### Parameters

- `DataSourceGetStatusParams parameters`

  - `required string pipelineID`

  - `required string dataSourceID`

### Returns

- `class ManagedIngestionStatusResponse:`

  - `required Status Status`

    Status of the ingestion.

    - `"CANCELLED"Cancelled`

    - `"ERROR"Error`

    - `"IN_PROGRESS"InProgress`

    - `"NOT_STARTED"NotStarted`

    - `"PARTIAL_SUCCESS"PartialSuccess`

    - `"SUCCESS"Success`

  - `DateTimeOffset? DeploymentDate`

    Date of the deployment.

  - `DateTimeOffset? EffectiveAt`

    When the status is effective

  - `IReadOnlyList<Error>? Error`

    List of errors that occurred during ingestion.

    - `required string JobID`

      ID of the job that failed.

    - `required string Message`

      List of errors that occurred during ingestion.

    - `required Step Step`

      Name of the job that failed.

      - `"DATA_SOURCE"DataSource`

      - `"FILE_UPDATER"FileUpdater`

      - `"INGESTION"Ingestion`

      - `"MANAGED_INGESTION"ManagedIngestion`

      - `"METADATA_UPDATE"MetadataUpdate`

      - `"PARSE"Parse`

      - `"TRANSFORM"Transform`

  - `string? JobID`

    ID of the latest job.

### Example

```csharp
DataSourceGetStatusParams parameters = new()
{
    PipelineID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    DataSourceID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
};

var managedIngestionStatusResponse = await client.Pipelines.DataSources.GetStatus(parameters);

Console.WriteLine(managedIngestionStatusResponse);
```

#### Response

```json
{
  "status": "CANCELLED",
  "deployment_date": "2019-12-27T18:11:19.117Z",
  "effective_at": "2019-12-27T18:11:19.117Z",
  "error": [
    {
      "job_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "message": "message",
      "step": "DATA_SOURCE"
    }
  ],
  "job_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
}
```

## Sync Pipeline Data Source

`Pipeline Pipelines.DataSources.Sync(DataSourceSyncParamsparameters, CancellationTokencancellationToken = default)`

**post** `/api/v1/pipelines/{pipeline_id}/data-sources/{data_source_id}/sync`

Run incremental ingestion: pull upstream changes from the data source into the data sink.

### Parameters

- `DataSourceSyncParams parameters`

  - `required string pipelineID`

    Path param

  - `required string dataSourceID`

    Path param

  - `IReadOnlyList<string>? pipelineFileIds`

    Body param

### Returns

- `class Pipeline:`

  Schema for a pipeline.

  - `required string ID`

    Unique identifier

  - `required EmbeddingConfig EmbeddingConfig`

    - `class AzureOpenAIEmbeddingConfig:`

      - `AzureOpenAIEmbedding Component`

        Configuration for the Azure OpenAI embedding model.

        - `IReadOnlyDictionary<string, JsonElement> AdditionalKwargs`

          Additional kwargs for the OpenAI API.

        - `string ApiBase`

          The base URL for Azure deployment.

        - `string? ApiKey`

          The OpenAI API key.

        - `string ApiVersion`

          The version for Azure OpenAI API.

        - `string? AzureDeployment`

          The Azure deployment to use.

        - `string? AzureEndpoint`

          The Azure endpoint to use.

        - `string ClassName`

        - `IReadOnlyDictionary<string, string>? DefaultHeaders`

          The default headers for API requests.

        - `Long? Dimensions`

          The number of dimensions on the output embedding vectors. Works only with v3 embedding models.

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `Long MaxRetries`

          Maximum number of retries.

        - `string ModelName`

          The name of the OpenAI embedding model.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `Boolean ReuseClient`

          Reuse the OpenAI client between requests. When doing anything with large volumes of async API calls, setting this to false can improve stability.

        - `Double Timeout`

          Timeout for each request.

      - `Type Type`

        Type of the embedding model.

        - `"AZURE_EMBEDDING"AzureEmbedding`

    - `class BedrockEmbeddingConfig:`

      - `BedrockEmbedding Component`

        Configuration for the Bedrock embedding model.

        - `IReadOnlyDictionary<string, JsonElement> AdditionalKwargs`

          Additional kwargs for the bedrock client.

        - `string? AwsAccessKeyID`

          AWS Access Key ID to use

        - `string? AwsSecretAccessKey`

          AWS Secret Access Key to use

        - `string? AwsSessionToken`

          AWS Session Token to use

        - `string ClassName`

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `Long MaxRetries`

          The maximum number of API retries.

        - `string ModelName`

          The modelId of the Bedrock model to use.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `string? ProfileName`

          The name of aws profile to use. If not given, then the default profile is used.

        - `string? RegionName`

          AWS region name to use. Uses region configured in AWS CLI if not passed

        - `Double Timeout`

          The timeout for the Bedrock API request in seconds. It will be used for both connect and read timeouts.

      - `Type Type`

        Type of the embedding model.

        - `"BEDROCK_EMBEDDING"BedrockEmbedding`

    - `class CohereEmbeddingConfig:`

      - `CohereEmbedding Component`

        Configuration for the Cohere embedding model.

        - `required string? ApiKey`

          The Cohere API key.

        - `string ClassName`

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `string EmbeddingType`

          Embedding type. If not provided float embedding_type is used when needed.

        - `string? InputType`

          Model Input type. If not provided, search_document and search_query are used when needed.

        - `string ModelName`

          The modelId of the Cohere model to use.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `string Truncate`

          Truncation type - START/ END/ NONE

      - `Type Type`

        Type of the embedding model.

        - `"COHERE_EMBEDDING"CohereEmbedding`

    - `class GeminiEmbeddingConfig:`

      - `GeminiEmbedding Component`

        Configuration for the Gemini embedding model.

        - `string? ApiBase`

          API base to access the model. Defaults to None.

        - `string? ApiKey`

          API key to access the model. Defaults to None.

        - `string ClassName`

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `string ModelName`

          The modelId of the Gemini model to use.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `Long? OutputDimensionality`

          Optional reduced dimension for output embeddings. Supported by models/text-embedding-004 and newer (e.g. gemini-embedding-001). Not supported by models/embedding-001.

        - `string? TaskType`

          The task for embedding model.

        - `string? Title`

          Title is only applicable for retrieval_document tasks, and is used to represent a document title. For other tasks, title is invalid.

        - `string? Transport`

          Transport to access the model. Defaults to None.

      - `Type Type`

        Type of the embedding model.

        - `"GEMINI_EMBEDDING"GeminiEmbedding`

    - `class HuggingFaceInferenceApiEmbeddingConfig:`

      - `HuggingFaceInferenceApiEmbedding Component`

        Configuration for the HuggingFace Inference API embedding model.

        - `Token? Token`

          Hugging Face token. Will default to the locally saved token. Pass token=False if you don’t want to send your token to the server.

          - `string`

          - `Boolean`

        - `string ClassName`

        - `IReadOnlyDictionary<string, string>? Cookies`

          Additional cookies to send to the server.

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `IReadOnlyDictionary<string, string>? Headers`

          Additional headers to send to the server. By default only the authorization and user-agent headers are sent. Values in this dictionary will override the default values.

        - `string? ModelName`

          Hugging Face model name. If None, the task will be used.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `Pooling? Pooling`

          Enum of possible pooling choices with pooling behaviors.

          - `"cls"Cls`

          - `"last"Last`

          - `"mean"Mean`

        - `string? QueryInstruction`

          Instruction to prepend during query embedding.

        - `string? Task`

          Optional task to pick Hugging Face's recommended model, used when model_name is left as default of None.

        - `string? TextInstruction`

          Instruction to prepend during text embedding.

        - `Double? Timeout`

          The maximum number of seconds to wait for a response from the server. Loading a new model in Inference API can take up to several minutes. Defaults to None, meaning it will loop until the server is available.

      - `Type Type`

        Type of the embedding model.

        - `"HUGGINGFACE_API_EMBEDDING"HuggingfaceApiEmbedding`

    - `class ManagedOpenAIEmbedding:`

      - `Component Component`

        Configuration for the Managed OpenAI embedding model.

        - `string ClassName`

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `ModelName ModelName`

          The name of the OpenAI embedding model.

          - `"openai-text-embedding-3-small"OpenAITextEmbedding3Small`

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

      - `Type Type`

        Type of the embedding model.

        - `"MANAGED_OPENAI_EMBEDDING"ManagedOpenAIEmbedding`

    - `class OpenAIEmbeddingConfig:`

      - `OpenAIEmbedding Component`

        Configuration for the OpenAI embedding model.

        - `IReadOnlyDictionary<string, JsonElement> AdditionalKwargs`

          Additional kwargs for the OpenAI API.

        - `string? ApiBase`

          The base URL for OpenAI API.

        - `string? ApiKey`

          The OpenAI API key.

        - `string? ApiVersion`

          The version for OpenAI API.

        - `string ClassName`

        - `IReadOnlyDictionary<string, string>? DefaultHeaders`

          The default headers for API requests.

        - `Long? Dimensions`

          The number of dimensions on the output embedding vectors. Works only with v3 embedding models.

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `Long MaxRetries`

          Maximum number of retries.

        - `string ModelName`

          The name of the OpenAI embedding model.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

        - `Boolean ReuseClient`

          Reuse the OpenAI client between requests. When doing anything with large volumes of async API calls, setting this to false can improve stability.

        - `Double Timeout`

          Timeout for each request.

      - `Type Type`

        Type of the embedding model.

        - `"OPENAI_EMBEDDING"OpenAIEmbedding`

    - `class VertexAIEmbeddingConfig:`

      - `VertexTextEmbedding Component`

        Configuration for the VertexAI embedding model.

        - `required string? ClientEmail`

          The client email for the VertexAI credentials.

        - `required string Location`

          The default location to use when making API calls.

        - `required string? PrivateKey`

          The private key for the VertexAI credentials.

        - `required string? PrivateKeyID`

          The private key ID for the VertexAI credentials.

        - `required string Project`

          The default GCP project to use when making Vertex API calls.

        - `required string? TokenUri`

          The token URI for the VertexAI credentials.

        - `IReadOnlyDictionary<string, JsonElement> AdditionalKwargs`

          Additional kwargs for the Vertex.

        - `string ClassName`

        - `Long EmbedBatchSize`

          The batch size for embedding calls.

        - `EmbedMode EmbedMode`

          The embedding mode to use.

          - `"classification"Classification`

          - `"clustering"Clustering`

          - `"default"Default`

          - `"retrieval"Retrieval`

          - `"similarity"Similarity`

        - `string ModelName`

          The modelId of the VertexAI model to use.

        - `Long? NumWorkers`

          The number of workers to use for async embedding calls.

      - `Type Type`

        Type of the embedding model.

        - `"VERTEXAI_EMBEDDING"VertexaiEmbedding`

  - `required string Name`

  - `required string ProjectID`

  - `ConfigHash? ConfigHash`

    Hashes for the configuration of a pipeline.

    - `string? EmbeddingConfigHash`

      Hash of the embedding config.

    - `string? ParsingConfigHash`

      Hash of the llama parse parameters.

    - `string? TransformConfigHash`

      Hash of the transform config.

  - `DateTimeOffset? CreatedAt`

    Creation datetime

  - `DataSink? DataSink`

    Schema for a data sink.

    - `required string ID`

      Unique identifier

    - `required Component Component`

      Component that implements the data sink

      - `IReadOnlyDictionary<string, JsonElement>`

      - `class CloudPineconeVectorStore:`

        Cloud Pinecone Vector Store.

        This class is used to store the configuration for a Pinecone vector store, so that it can be
        created and used in LlamaCloud.

        Args:
        api_key (str): API key for authenticating with Pinecone
        index_name (str): name of the Pinecone index
        namespace (optional[str]): namespace to use in the Pinecone index
        insert_kwargs (optional[dict]): additional kwargs to pass during insertion

        - `required string ApiKey`

          The API key for authenticating with Pinecone

        - `required string IndexName`

        - `string ClassName`

        - `IReadOnlyDictionary<string, JsonElement>? InsertKwargs`

        - `string? Namespace`

        - `SupportsNestedMetadataFilters SupportsNestedMetadataFilters`

          - `trueTrue`

      - `class CloudPostgresVectorStore:`

        - `required string Database`

        - `required Long EmbedDim`

        - `required string Host`

        - `required string Password`

        - `required Long Port`

        - `required string SchemaName`

        - `required string TableName`

        - `required string User`

        - `string ClassName`

        - `PgVectorHnswSettings? HnswSettings`

          HNSW settings for PGVector.

          - `DistanceMethod DistanceMethod`

            The distance method to use.

            - `"cosine"Cosine`

            - `"hamming"Hamming`

            - `"ip"IP`

            - `"jaccard"Jaccard`

            - `"l1"L1`

            - `"l2"L2`

          - `Long EfConstruction`

            The number of edges to use during the construction phase.

          - `Long EfSearch`

            The number of edges to use during the search phase.

          - `Long M`

            The number of bi-directional links created for each new element.

          - `VectorType VectorType`

            The type of vector to use.

            - `"bit"Bit`

            - `"half_vec"HalfVec`

            - `"sparse_vec"SparseVec`

            - `"vector"Vector`

        - `Boolean? HybridSearch`

        - `Boolean PerformSetup`

        - `Boolean SupportsNestedMetadataFilters`

      - `class CloudQdrantVectorStore:`

        Cloud Qdrant Vector Store.

        This class is used to store the configuration for a Qdrant vector store, so that it can be
        created and used in LlamaCloud.

        Args:
        collection_name (str): name of the Qdrant collection
        url (str): url of the Qdrant instance
        api_key (str): API key for authenticating with Qdrant
        max_retries (int): maximum number of retries in case of a failure. Defaults to 3
        client_kwargs (dict): additional kwargs to pass to the Qdrant client

        - `required string ApiKey`

        - `required string CollectionName`

        - `required string Url`

        - `string ClassName`

        - `IReadOnlyDictionary<string, JsonElement> ClientKwargs`

        - `Long MaxRetries`

        - `SupportsNestedMetadataFilters SupportsNestedMetadataFilters`

          - `trueTrue`

      - `class CloudAzureAISearchVectorStore:`

        Cloud Azure AI Search Vector Store.

        - `required string SearchServiceApiKey`

        - `required string SearchServiceEndpoint`

        - `string ClassName`

        - `string? ClientID`

        - `string? ClientSecret`

        - `Long? EmbeddingDimension`

        - `IReadOnlyDictionary<string, JsonElement>? FilterableMetadataFieldKeys`

        - `string? IndexName`

        - `string? SearchServiceApiVersion`

        - `SupportsNestedMetadataFilters SupportsNestedMetadataFilters`

          - `trueTrue`

        - `string? TenantID`

      - `class CloudMongoDBAtlasVectorSearch:`

        Cloud MongoDB Atlas Vector Store.

        This class is used to store the configuration for a MongoDB Atlas vector store,
        so that it can be created and used in LlamaCloud.

        Args:
        mongodb_uri (str): URI for connecting to MongoDB Atlas
        db_name (str): name of the MongoDB database
        collection_name (str): name of the MongoDB collection
        vector_index_name (str): name of the MongoDB Atlas vector index
        fulltext_index_name (str): name of the MongoDB Atlas full-text index

        - `required string CollectionName`

        - `required string DBName`

        - `required string MongoDBUri`

        - `string ClassName`

        - `Long? EmbeddingDimension`

        - `string? FulltextIndexName`

        - `Boolean SupportsNestedMetadataFilters`

        - `string? VectorIndexName`

      - `class CloudMilvusVectorStore:`

        Cloud Milvus Vector Store.

        - `required string Uri`

        - `string? Token`

        - `string ClassName`

        - `string? CollectionName`

        - `Long? EmbeddingDimension`

        - `Boolean SupportsNestedMetadataFilters`

      - `class CloudAstraDBVectorStore:`

        Cloud AstraDB Vector Store.

        This class is used to store the configuration for an AstraDB vector store, so that it can be
        created and used in LlamaCloud.

        Args:
        token (str): The Astra DB Application Token to use.
        api_endpoint (str): The Astra DB JSON API endpoint for your database.
        collection_name (str): Collection name to use. If not existing, it will be created.
        embedding_dimension (int): Length of the embedding vectors in use.
        keyspace (optional[str]): The keyspace to use. If not provided, 'default_keyspace'

        - `required string Token`

          The Astra DB Application Token to use

        - `required string ApiEndpoint`

          The Astra DB JSON API endpoint for your database

        - `required string CollectionName`

          Collection name to use. If not existing, it will be created

        - `required Long EmbeddingDimension`

          Length of the embedding vectors in use

        - `string ClassName`

        - `string? Keyspace`

          The keyspace to use. If not provided, 'default_keyspace'

        - `SupportsNestedMetadataFilters SupportsNestedMetadataFilters`

          - `trueTrue`

    - `required string Name`

      The name of the data sink.

    - `required string ProjectID`

    - `required SinkType SinkType`

      - `"ASTRA_DB"AstraDB`

      - `"AZUREAI_SEARCH"AzureaiSearch`

      - `"MILVUS"Milvus`

      - `"MONGODB_ATLAS"MongoDBAtlas`

      - `"PINECONE"Pinecone`

      - `"POSTGRES"Postgres`

      - `"QDRANT"Qdrant`

    - `DateTimeOffset? CreatedAt`

      Creation datetime

    - `DateTimeOffset? UpdatedAt`

      Update datetime

  - `EmbeddingModelConfig? EmbeddingModelConfig`

    Schema for an embedding model config.

    - `required string ID`

      Unique identifier

    - `required EmbeddingConfig EmbeddingConfig`

      The embedding configuration for the embedding model config.

      - `class AzureOpenAIEmbeddingConfig:`

      - `class BedrockEmbeddingConfig:`

      - `class CohereEmbeddingConfig:`

      - `class GeminiEmbeddingConfig:`

      - `class HuggingFaceInferenceApiEmbeddingConfig:`

      - `class OpenAIEmbeddingConfig:`

      - `class VertexAIEmbeddingConfig:`

    - `required string Name`

      The name of the embedding model config.

    - `required string ProjectID`

    - `DateTimeOffset? CreatedAt`

      Creation datetime

    - `DateTimeOffset? UpdatedAt`

      Update datetime

  - `string? EmbeddingModelConfigID`

    The ID of the EmbeddingModelConfig this pipeline is using.

  - `LlamaParseParameters? LlamaParseParameters`

    Settings that can be configured for how to use LlamaParse to parse files within a LlamaCloud pipeline.

    - `Boolean? AdaptiveLongTable`

    - `Boolean? AggressiveTableExtraction`

    - `Boolean? AnnotateLinks`

    - `Boolean? AutoMode`

    - `string? AutoModeConfigurationJson`

    - `Boolean? AutoModeTriggerOnImageInPage`

    - `string? AutoModeTriggerOnRegexpInPage`

    - `Boolean? AutoModeTriggerOnTableInPage`

    - `string? AutoModeTriggerOnTextInPage`

    - `string? AzureOpenAIApiVersion`

    - `string? AzureOpenAIDeploymentName`

    - `string? AzureOpenAIEndpoint`

    - `string? AzureOpenAIKey`

    - `Double? BboxBottom`

    - `Double? BboxLeft`

    - `Double? BboxRight`

    - `Double? BboxTop`

    - `string? BoundingBox`

    - `Boolean? CompactMarkdownTable`

    - `string? ComplementalFormattingInstruction`

    - `string? ConfidenceScoreEffort`

    - `string? ContentGuidelineInstruction`

    - `Boolean? ContinuousMode`

    - `Boolean? DisableImageExtraction`

    - `Boolean? DisableOcr`

    - `Boolean? DisableReconstruction`

    - `Boolean? DoNotCache`

    - `Boolean? DoNotUnrollColumns`

    - `Boolean? EnableCostOptimizer`

    - `Boolean? ExtractCharts`

    - `Boolean? ExtractLayout`

    - `Boolean? ExtractPrintedPageNumber`

    - `Boolean? FastMode`

    - `string? FormattingInstruction`

    - `string? Gpt4oApiKey`

    - `Boolean? Gpt4oMode`

    - `Boolean? GuessXlsxSheetName`

    - `Boolean? HideFooters`

    - `Boolean? HideHeaders`

    - `Boolean? HighResOcr`

    - `Boolean? HtmlMakeAllElementsVisible`

    - `Boolean? HtmlRemoveFixedElements`

    - `Boolean? HtmlRemoveNavigationElements`

    - `string? HttpProxy`

    - `Boolean? IgnoreDocumentElementsForLayoutDetection`

    - `IReadOnlyList<ImagesToSave>? ImagesToSave`

      - `"embedded"Embedded`

      - `"layout"Layout`

      - `"screenshot"Screenshot`

    - `Boolean? InlineImagesInMarkdown`

    - `string? InputS3Path`

    - `string? InputS3Region`

    - `string? InputUrl`

    - `Boolean? InternalIsScreenshotJob`

    - `Boolean? InvalidateCache`

    - `Boolean? IsFormattingInstruction`

    - `Double? JobTimeoutExtraTimePerPageInSeconds`

    - `Double? JobTimeoutInSeconds`

    - `Boolean? KeepPageSeparatorWhenMergingTables`

    - `IReadOnlyList<ParsingLanguages> Languages`

      - `"abq"Abq`

      - `"ady"Ady`

      - `"af"Af`

      - `"ang"Ang`

      - `"ar"Ar`

      - `"as"As`

      - `"ava"Ava`

      - `"az"Az`

      - `"be"Be`

      - `"bg"Bg`

      - `"bgc"Bgc`

      - `"bh"Bh`

      - `"bho"Bho`

      - `"bn"Bn`

      - `"bs"Bs`

      - `"ch_sim"ChSim`

      - `"ch_tra"ChTra`

      - `"che"Che`

      - `"cs"Cs`

      - `"cy"Cy`

      - `"da"Da`

      - `"dar"Dar`

      - `"de"De`

      - `"en"En`

      - `"es"Es`

      - `"et"Et`

      - `"fa"Fa`

      - `"fr"Fr`

      - `"ga"Ga`

      - `"gom"Gom`

      - `"hi"Hi`

      - `"hr"Hr`

      - `"hu"Hu`

      - `"id"ID`

      - `"inh"Inh`

      - `"is"Is`

      - `"it"It`

      - `"ja"Ja`

      - `"kbd"Kbd`

      - `"kn"Kn`

      - `"ko"Ko`

      - `"ku"Ku`

      - `"la"La`

      - `"lbe"Lbe`

      - `"lez"Lez`

      - `"lt"Lt`

      - `"lv"Lv`

      - `"mah"Mah`

      - `"mai"Mai`

      - `"mi"Mi`

      - `"mn"Mn`

      - `"mni"Mni`

      - `"mr"Mr`

      - `"ms"Ms`

      - `"mt"Mt`

      - `"ne"Ne`

      - `"new"New`

      - `"nl"Nl`

      - `"no"No`

      - `"oc"Oc`

      - `"pi"Pi`

      - `"pl"Pl`

      - `"pt"Pt`

      - `"ro"Ro`

      - `"rs_cyrillic"RsCyrillic`

      - `"rs_latin"RsLatin`

      - `"ru"Ru`

      - `"sa"Sa`

      - `"sck"Sck`

      - `"sk"Sk`

      - `"sl"Sl`

      - `"sq"Sq`

      - `"sv"Sv`

      - `"sw"Sw`

      - `"ta"Ta`

      - `"tab"Tab`

      - `"te"Te`

      - `"th"Th`

      - `"tjk"Tjk`

      - `"tl"Tl`

      - `"tr"Tr`

      - `"ug"Ug`

      - `"uk"Uk`

      - `"ur"Ur`

      - `"uz"Uz`

      - `"vi"Vi`

    - `Boolean? LayoutAware`

    - `Boolean? LineLevelBoundingBox`

    - `string? MarkdownTableMultilineHeaderSeparator`

    - `Long? MaxPages`

    - `Long? MaxPagesEnforced`

    - `Boolean? MergeTablesAcrossPagesInMarkdown`

    - `string? Model`

    - `Boolean? OutlinedTableExtraction`

    - `Boolean? OutputPdfOfDocument`

    - `string? OutputS3PathPrefix`

    - `string? OutputS3Region`

    - `Boolean? OutputTablesAsHtml`

    - `Double? PageErrorTolerance`

    - `string? PageFooterPrefix`

    - `string? PageFooterSuffix`

    - `string? PageHeaderPrefix`

    - `string? PageHeaderSuffix`

    - `string? PagePrefix`

    - `string? PageSeparator`

    - `string? PageSuffix`

    - `ParsingMode? ParseMode`

      Enum for representing the mode of parsing to be used.

      - `"parse_document_with_agent"ParseDocumentWithAgent`

      - `"parse_document_with_llm"ParseDocumentWithLlm`

      - `"parse_document_with_lvm"ParseDocumentWithLvm`

      - `"parse_page_with_agent"ParsePageWithAgent`

      - `"parse_page_with_layout_agent"ParsePageWithLayoutAgent`

      - `"parse_page_with_llm"ParsePageWithLlm`

      - `"parse_page_with_lvm"ParsePageWithLvm`

      - `"parse_page_without_llm"ParsePageWithoutLlm`

    - `string? ParsingInstruction`

    - `Boolean? PreciseBoundingBox`

    - `Boolean? PremiumMode`

    - `Boolean? PresentationOutOfBoundsContent`

    - `Boolean? PresentationSkipEmbeddedData`

    - `Boolean? PreserveLayoutAlignmentAcrossPages`

    - `Boolean? PreserveVerySmallText`

    - `string? Preset`

    - `Priority? Priority`

      The priority for the request. This field may be ignored or overwritten depending on the organization tier.

      - `"critical"Critical`

      - `"high"High`

      - `"low"Low`

      - `"medium"Medium`

    - `string? ProjectID`

    - `Boolean? RemoveHiddenText`

    - `FailPageMode? ReplaceFailedPageMode`

      Enum for representing the different available page error handling modes.

      - `"blank_page"BlankPage`

      - `"error_message"ErrorMessage`

      - `"raw_text"RawText`

    - `string? ReplaceFailedPageWithErrorMessagePrefix`

    - `string? ReplaceFailedPageWithErrorMessageSuffix`

    - `Boolean? SaveImages`

    - `Boolean? SkipDiagonalText`

    - `Boolean? SpecializedChartParsingAgentic`

    - `Boolean? SpecializedChartParsingEfficient`

    - `Boolean? SpecializedChartParsingPlus`

    - `Boolean? SpecializedImageParsing`

    - `Boolean? SpreadsheetExtractSubTables`

    - `Boolean? SpreadsheetForceFormulaComputation`

    - `Boolean? SpreadsheetIncludeHiddenSheets`

    - `Boolean? StrictModeBuggyFont`

    - `Boolean? StrictModeImageExtraction`

    - `Boolean? StrictModeImageOcr`

    - `Boolean? StrictModeReconstruction`

    - `Boolean? StructuredOutput`

    - `string? StructuredOutputJsonSchema`

    - `string? StructuredOutputJsonSchemaName`

    - `string? SystemPrompt`

    - `string? SystemPromptAppend`

    - `Boolean? TakeScreenshot`

    - `string? TargetPages`

    - `string? Tier`

    - `Boolean? UseVendorMultimodalModel`

    - `string? UserPrompt`

    - `string? VendorMultimodalApiKey`

    - `string? VendorMultimodalModelName`

    - `string? Version`

    - `IReadOnlyList<WebhookConfiguration>? WebhookConfigurations`

      Outbound webhook endpoints to notify on job status changes

      - `IReadOnlyList<WebhookEvent>? WebhookEvents`

        Events to subscribe to (e.g. 'parse.success', 'extract.error'). If null, all events are delivered.

        - `"classify.cancelled"ClassifyCancelled`

        - `"classify.error"ClassifyError`

        - `"classify.partial_success"ClassifyPartialSuccess`

        - `"classify.pending"ClassifyPending`

        - `"classify.running"ClassifyRunning`

        - `"classify.success"ClassifySuccess`

        - `"extract.cancelled"ExtractCancelled`

        - `"extract.error"ExtractError`

        - `"extract.partial_success"ExtractPartialSuccess`

        - `"extract.pending"ExtractPending`

        - `"extract.success"ExtractSuccess`

        - `"parse.cancelled"ParseCancelled`

        - `"parse.error"ParseError`

        - `"parse.partial_success"ParsePartialSuccess`

        - `"parse.pending"ParsePending`

        - `"parse.running"ParseRunning`

        - `"parse.success"ParseSuccess`

        - `"sheets.cancelled"SheetsCancelled`

        - `"sheets.error"SheetsError`

        - `"sheets.partial_success"SheetsPartialSuccess`

        - `"sheets.pending"SheetsPending`

        - `"sheets.success"SheetsSuccess`

        - `"split.cancelled"SplitCancelled`

        - `"split.error"SplitError`

        - `"split.pending"SplitPending`

        - `"split.processing"SplitProcessing`

        - `"split.success"SplitSuccess`

        - `"unmapped_event"UnmappedEvent`

      - `IReadOnlyDictionary<string, string>? WebhookHeaders`

        Custom HTTP headers sent with each webhook request (e.g. auth tokens)

      - `string? WebhookOutputFormat`

        Response format sent to the webhook: 'string' (default) or 'json'

      - `string? WebhookSigningSecret`

        Shared signing secret used to sign webhook deliveries. When set, each request includes an HMAC-SHA256 signature of the request body in the 'LC-Signature' header (value 'sha256=<hex>'). Recompute the HMAC over the raw request body with this secret to verify the delivery is authentic.

      - `string? WebhookUrl`

        URL to receive webhook POST notifications

    - `string? WebhookUrl`

  - `string? ManagedPipelineID`

    The ID of the ManagedPipeline this playground pipeline is linked to.

  - `PipelineMetadataConfig? MetadataConfig`

    Metadata configuration for the pipeline.

    - `IReadOnlyList<string> ExcludedEmbedMetadataKeys`

      List of metadata keys to exclude from embeddings

    - `IReadOnlyList<string> ExcludedLlmMetadataKeys`

      List of metadata keys to exclude from LLM during retrieval

  - `PipelineType PipelineType`

    Type of pipeline. Either PLAYGROUND or MANAGED.

    - `"MANAGED"Managed`

    - `"PLAYGROUND"Playground`

  - `PresetRetrievalParams PresetRetrievalParameters`

    Preset retrieval parameters for the pipeline.

    - `Double? Alpha`

      Alpha value for hybrid retrieval to determine the weights between dense and sparse retrieval. 0 is sparse retrieval and 1 is dense retrieval.

    - `string ClassName`

    - `Double? DenseSimilarityCutoff`

      Minimum similarity score wrt query for retrieval

    - `Long? DenseSimilarityTopK`

      Number of nodes for dense retrieval.

    - `Boolean? EnableReranking`

      Enable reranking for retrieval

    - `Long? FilesTopK`

      Number of files to retrieve (only for retrieval mode files_via_metadata and files_via_content).

    - `Long? RerankTopN`

      Number of reranked nodes for returning.

    - `RetrievalMode RetrievalMode`

      The retrieval mode for the query.

      - `"auto_routed"AutoRouted`

      - `"chunks"Chunks`

      - `"files_via_content"FilesViaContent`

      - `"files_via_metadata"FilesViaMetadata`

    - `Boolean RetrieveImageNodes`

      Whether to retrieve image nodes.

    - `Boolean RetrievePageFigureNodes`

      Whether to retrieve page figure nodes.

    - `Boolean RetrievePageScreenshotNodes`

      Whether to retrieve page screenshot nodes.

    - `MetadataFilters? SearchFilters`

      Metadata filters for vector stores.

      - `required IReadOnlyList<Filter> Filters`

        - `class MetadataFilter:`

          Comprehensive metadata filter for vector stores to support more operators.

          Value uses Strict types, as int, float and str are compatible types and were all
          converted to string before.

          See: https://docs.pydantic.dev/latest/usage/types/#strict-types

          - `required string Key`

          - `required Value? Value`

            - `Double`

            - `string`

            - `IReadOnlyList<string>`

            - `IReadOnlyList<Double>`

            - `IReadOnlyList<Long>`

          - `Operator Operator`

            Vector store filter operator.

            - `"!="`

            - `"<"`

            - `"<="`

            - `"=="`

            - `">"`

            - `">="`

            - `"all"All`

            - `"any"Any`

            - `"contains"Contains`

            - `"in"In`

            - `"is_empty"IsEmpty`

            - `"nin"Nin`

            - `"text_match"TextMatch`

            - `"text_match_insensitive"TextMatchInsensitive`

        - `class MetadataFilters:`

          Metadata filters for vector stores.

      - `Condition? Condition`

        Vector store filter conditions to combine different filters.

        - `"and"And`

        - `"not"Not`

        - `"or"Or`

    - `IReadOnlyDictionary<string, SearchFiltersInferenceSchema?>? SearchFiltersInferenceSchema`

      JSON Schema that will be used to infer search_filters. Omit or leave as null to skip inference.

      - `IReadOnlyDictionary<string, JsonElement>`

      - `IReadOnlyList<JsonElement>`

      - `string`

      - `Double`

      - `Boolean`

    - `Long? SparseSimilarityTopK`

      Number of nodes for sparse retrieval.

  - `SparseModelConfig? SparseModelConfig`

    Configuration for sparse embedding models used in hybrid search.

    This allows users to choose between Splade and BM25 models for
    sparse retrieval in managed data sinks.

    - `string ClassName`

    - `ModelType ModelType`

      The sparse model type to use. 'bm25' uses Qdrant's FastEmbed BM25 model (default for new pipelines), 'splade' uses HuggingFace Splade model, 'auto' selects based on deployment mode (BYOC uses term frequency, Cloud uses Splade).

      - `"auto"Auto`

      - `"bm25"Bm25`

      - `"splade"Splade`

  - `Status? Status`

    Status of the pipeline.

    - `"CREATED"Created`

    - `"DELETING"Deleting`

  - `TransformConfig TransformConfig`

    Configuration for the transformation.

    - `class AutoTransformConfig:`

      - `Long ChunkOverlap`

        Chunk overlap for the transformation.

      - `Long ChunkSize`

        Chunk size for the transformation.

      - `Mode Mode`

        - `"auto"Auto`

    - `class AdvancedModeTransformConfig:`

      - `ChunkingConfig ChunkingConfig`

        Configuration for the chunking.

        - `class NoneChunkingConfig:`

          - `Mode Mode`

            - `"none"None`

        - `class CharacterChunkingConfig:`

          - `Long ChunkOverlap`

          - `Long ChunkSize`

          - `Mode Mode`

            - `"character"Character`

        - `class TokenChunkingConfig:`

          - `Long ChunkOverlap`

          - `Long ChunkSize`

          - `Mode Mode`

            - `"token"Token`

          - `string Separator`

        - `class SentenceChunkingConfig:`

          - `Long ChunkOverlap`

          - `Long ChunkSize`

          - `Mode Mode`

            - `"sentence"Sentence`

          - `string ParagraphSeparator`

          - `string Separator`

        - `class SemanticChunkingConfig:`

          - `Long BreakpointPercentileThreshold`

          - `Long BufferSize`

          - `Mode Mode`

            - `"semantic"Semantic`

      - `Mode Mode`

        - `"advanced"Advanced`

      - `SegmentationConfig SegmentationConfig`

        Configuration for the segmentation.

        - `class NoneSegmentationConfig:`

          - `Mode Mode`

            - `"none"None`

        - `class PageSegmentationConfig:`

          - `Mode Mode`

            - `"page"Page`

          - `string PageSeparator`

        - `class ElementSegmentationConfig:`

          - `Mode Mode`

            - `"element"Element`

  - `DateTimeOffset? UpdatedAt`

    Update datetime

### Example

```csharp
DataSourceSyncParams parameters = new()
{
    PipelineID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    DataSourceID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
};

var pipeline = await client.Pipelines.DataSources.Sync(parameters);

Console.WriteLine(pipeline);
```

#### Response

```json
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "embedding_config": {
    "component": {
      "additional_kwargs": {
        "foo": "bar"
      },
      "api_base": "api_base",
      "api_key": "api_key",
      "api_version": "api_version",
      "azure_deployment": "azure_deployment",
      "azure_endpoint": "azure_endpoint",
      "class_name": "class_name",
      "default_headers": {
        "foo": "string"
      },
      "dimensions": 0,
      "embed_batch_size": 1,
      "max_retries": 0,
      "model_name": "model_name",
      "num_workers": 0,
      "reuse_client": true,
      "timeout": 0
    },
    "type": "AZURE_EMBEDDING"
  },
  "name": "name",
  "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "config_hash": {
    "embedding_config_hash": "embedding_config_hash",
    "parsing_config_hash": "parsing_config_hash",
    "transform_config_hash": "transform_config_hash"
  },
  "created_at": "2019-12-27T18:11:19.117Z",
  "data_sink": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "component": {
      "foo": "bar"
    },
    "name": "name",
    "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "sink_type": "ASTRA_DB",
    "created_at": "2019-12-27T18:11:19.117Z",
    "updated_at": "2019-12-27T18:11:19.117Z"
  },
  "embedding_model_config": {
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "embedding_config": {
      "component": {
        "additional_kwargs": {
          "foo": "bar"
        },
        "api_base": "api_base",
        "api_key": "api_key",
        "api_version": "api_version",
        "azure_deployment": "azure_deployment",
        "azure_endpoint": "azure_endpoint",
        "class_name": "class_name",
        "default_headers": {
          "foo": "string"
        },
        "dimensions": 0,
        "embed_batch_size": 1,
        "max_retries": 0,
        "model_name": "model_name",
        "num_workers": 0,
        "reuse_client": true,
        "timeout": 0
      },
      "type": "AZURE_EMBEDDING"
    },
    "name": "name",
    "project_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "created_at": "2019-12-27T18:11:19.117Z",
    "updated_at": "2019-12-27T18:11:19.117Z"
  },
  "embedding_model_config_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "llama_parse_parameters": {
    "adaptive_long_table": true,
    "aggressive_table_extraction": true,
    "annotate_links": true,
    "auto_mode": true,
    "auto_mode_configuration_json": "auto_mode_configuration_json",
    "auto_mode_trigger_on_image_in_page": true,
    "auto_mode_trigger_on_regexp_in_page": "auto_mode_trigger_on_regexp_in_page",
    "auto_mode_trigger_on_table_in_page": true,
    "auto_mode_trigger_on_text_in_page": "auto_mode_trigger_on_text_in_page",
    "azure_openai_api_version": "azure_openai_api_version",
    "azure_openai_deployment_name": "azure_openai_deployment_name",
    "azure_openai_endpoint": "azure_openai_endpoint",
    "azure_openai_key": "azure_openai_key",
    "bbox_bottom": 0,
    "bbox_left": 0,
    "bbox_right": 0,
    "bbox_top": 0,
    "bounding_box": "bounding_box",
    "compact_markdown_table": true,
    "complemental_formatting_instruction": "complemental_formatting_instruction",
    "confidence_score_effort": "confidence_score_effort",
    "content_guideline_instruction": "content_guideline_instruction",
    "continuous_mode": true,
    "disable_image_extraction": true,
    "disable_ocr": true,
    "disable_reconstruction": true,
    "do_not_cache": true,
    "do_not_unroll_columns": true,
    "enable_cost_optimizer": true,
    "extract_charts": true,
    "extract_layout": true,
    "extract_printed_page_number": true,
    "fast_mode": true,
    "formatting_instruction": "formatting_instruction",
    "gpt4o_api_key": "gpt4o_api_key",
    "gpt4o_mode": true,
    "guess_xlsx_sheet_name": true,
    "hide_footers": true,
    "hide_headers": true,
    "high_res_ocr": true,
    "html_make_all_elements_visible": true,
    "html_remove_fixed_elements": true,
    "html_remove_navigation_elements": true,
    "http_proxy": "http_proxy",
    "ignore_document_elements_for_layout_detection": true,
    "images_to_save": [
      "embedded"
    ],
    "inline_images_in_markdown": true,
    "input_s3_path": "input_s3_path",
    "input_s3_region": "input_s3_region",
    "input_url": "input_url",
    "internal_is_screenshot_job": true,
    "invalidate_cache": true,
    "is_formatting_instruction": true,
    "job_timeout_extra_time_per_page_in_seconds": 0,
    "job_timeout_in_seconds": 0,
    "keep_page_separator_when_merging_tables": true,
    "languages": [
      "abq"
    ],
    "layout_aware": true,
    "line_level_bounding_box": true,
    "markdown_table_multiline_header_separator": "markdown_table_multiline_header_separator",
    "max_pages": 0,
    "max_pages_enforced": 0,
    "merge_tables_across_pages_in_markdown": true,
    "model": "model",
    "outlined_table_extraction": true,
    "output_pdf_of_document": true,
    "output_s3_path_prefix": "output_s3_path_prefix",
    "output_s3_region": "output_s3_region",
    "output_tables_as_HTML": true,
    "page_error_tolerance": 0,
    "page_footer_prefix": "page_footer_prefix",
    "page_footer_suffix": "page_footer_suffix",
    "page_header_prefix": "page_header_prefix",
    "page_header_suffix": "page_header_suffix",
    "page_prefix": "page_prefix",
    "page_separator": "page_separator",
    "page_suffix": "page_suffix",
    "parse_mode": "parse_document_with_agent",
    "parsing_instruction": "parsing_instruction",
    "precise_bounding_box": true,
    "premium_mode": true,
    "presentation_out_of_bounds_content": true,
    "presentation_skip_embedded_data": true,
    "preserve_layout_alignment_across_pages": true,
    "preserve_very_small_text": true,
    "preset": "preset",
    "priority": "critical",
    "project_id": "project_id",
    "remove_hidden_text": true,
    "replace_failed_page_mode": "blank_page",
    "replace_failed_page_with_error_message_prefix": "replace_failed_page_with_error_message_prefix",
    "replace_failed_page_with_error_message_suffix": "replace_failed_page_with_error_message_suffix",
    "save_images": true,
    "skip_diagonal_text": true,
    "specialized_chart_parsing_agentic": true,
    "specialized_chart_parsing_efficient": true,
    "specialized_chart_parsing_plus": true,
    "specialized_image_parsing": true,
    "spreadsheet_extract_sub_tables": true,
    "spreadsheet_force_formula_computation": true,
    "spreadsheet_include_hidden_sheets": true,
    "strict_mode_buggy_font": true,
    "strict_mode_image_extraction": true,
    "strict_mode_image_ocr": true,
    "strict_mode_reconstruction": true,
    "structured_output": true,
    "structured_output_json_schema": "structured_output_json_schema",
    "structured_output_json_schema_name": "structured_output_json_schema_name",
    "system_prompt": "system_prompt",
    "system_prompt_append": "system_prompt_append",
    "take_screenshot": true,
    "target_pages": "target_pages",
    "tier": "tier",
    "use_vendor_multimodal_model": true,
    "user_prompt": "user_prompt",
    "vendor_multimodal_api_key": "vendor_multimodal_api_key",
    "vendor_multimodal_model_name": "vendor_multimodal_model_name",
    "version": "version",
    "webhook_configurations": [
      {
        "webhook_events": [
          "parse.success",
          "parse.error"
        ],
        "webhook_headers": {
          "Authorization": "Bearer sk-..."
        },
        "webhook_output_format": "json",
        "webhook_signing_secret": "whsec_...",
        "webhook_url": "https://example.com/webhooks/llamacloud"
      }
    ],
    "webhook_url": "webhook_url"
  },
  "managed_pipeline_id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "metadata_config": {
    "excluded_embed_metadata_keys": [
      "string"
    ],
    "excluded_llm_metadata_keys": [
      "string"
    ]
  },
  "pipeline_type": "MANAGED",
  "preset_retrieval_parameters": {
    "alpha": 0,
    "class_name": "class_name",
    "dense_similarity_cutoff": 0,
    "dense_similarity_top_k": 1,
    "enable_reranking": true,
    "files_top_k": 1,
    "rerank_top_n": 1,
    "retrieval_mode": "auto_routed",
    "retrieve_image_nodes": true,
    "retrieve_page_figure_nodes": true,
    "retrieve_page_screenshot_nodes": true,
    "search_filters": {
      "filters": [
        {
          "key": "key",
          "value": 0,
          "operator": "!="
        }
      ],
      "condition": "and"
    },
    "search_filters_inference_schema": {
      "foo": {
        "foo": "bar"
      }
    },
    "sparse_similarity_top_k": 1
  },
  "sparse_model_config": {
    "class_name": "class_name",
    "model_type": "auto"
  },
  "status": "CREATED",
  "transform_config": {
    "chunk_overlap": 0,
    "chunk_size": 1,
    "mode": "auto"
  },
  "updated_at": "2019-12-27T18:11:19.117Z"
}
```

## Domain Types

### Pipeline Data Source

- `class PipelineDataSource:`

  Schema for a data source in a pipeline.

  - `required string ID`

    Unique identifier

  - `required Component Component`

    Component that implements the data source

    - `IReadOnlyDictionary<string, JsonElement>`

    - `class CloudS3DataSource:`

      - `required string Bucket`

        The name of the S3 bucket to read from.

      - `string? AwsAccessID`

        The AWS access ID to use for authentication.

      - `string? AwsAccessSecret`

        The AWS access secret to use for authentication.

      - `string ClassName`

      - `string? Prefix`

        The prefix of the S3 objects to read from.

      - `string? RegexPattern`

        The regex pattern to filter S3 objects. Must be a valid regex pattern.

      - `string? S3EndpointUrl`

        The S3 endpoint URL to use for authentication.

      - `Boolean SupportsAccessControl`

    - `class CloudAzStorageBlobDataSource:`

      - `required string AccountUrl`

        The Azure Storage Blob account URL to use for authentication.

      - `required string ContainerName`

        The name of the Azure Storage Blob container to read from.

      - `string? AccountKey`

        The Azure Storage Blob account key to use for authentication.

      - `string? AccountName`

        The Azure Storage Blob account name to use for authentication.

      - `string? Blob`

        The blob name to read from.

      - `string ClassName`

      - `string? ClientID`

        The Azure AD client ID to use for authentication.

      - `string? ClientSecret`

        The Azure AD client secret to use for authentication.

      - `string? Prefix`

        The prefix of the Azure Storage Blob objects to read from.

      - `Boolean SupportsAccessControl`

      - `string? TenantID`

        The Azure AD tenant ID to use for authentication.

    - `class CloudGoogleDriveDataSource:`

      - `required string FolderID`

        The ID of the Google Drive folder to read from.

      - `string ClassName`

      - `string? FolderName`

        Human-readable name of the selected folder, for display.

      - `IReadOnlyDictionary<string, string>? ServiceAccountKey`

        A dictionary containing secret values

      - `Boolean SupportsAccessControl`

    - `class CloudOneDriveDataSource:`

      - `required string ClientID`

        The client ID to use for authentication.

      - `required string ClientSecret`

        The client secret to use for authentication.

      - `required string TenantID`

        The tenant ID to use for authentication.

      - `required string UserPrincipalName`

        The user principal name to use for authentication.

      - `string ClassName`

      - `string? FolderID`

        The ID of the OneDrive folder to read from.

      - `string? FolderPath`

        The path of the OneDrive folder to read from.

      - `IReadOnlyList<string>? RequiredExts`

        The list of required file extensions.

      - `SupportsAccessControl SupportsAccessControl`

        - `trueTrue`

    - `class CloudSharepointDataSource:`

      - `required string ClientID`

        The client ID to use for authentication.

      - `required string ClientSecret`

        The client secret to use for authentication.

      - `required string TenantID`

        The tenant ID to use for authentication.

      - `string ClassName`

      - `string? DriveName`

        The name of the Sharepoint drive to read from.

      - `IReadOnlyList<string>? ExcludePathPatterns`

        List of regex patterns for file paths to exclude. Files whose paths (including filename) match any pattern will be excluded. Example: ['/temp/', '/backup/', '.git/', '.tmp$', '^~']

      - `string? FolderID`

        The ID of the Sharepoint folder to read from.

      - `string? FolderPath`

        The path of the Sharepoint folder to read from.

      - `Boolean GetPermissions`

        Whether to get permissions for the sharepoint site.

      - `IReadOnlyList<string>? IncludePathPatterns`

        List of regex patterns for file paths to include. Full paths (including filename) must match at least one pattern to be included. Example: ['/reports/', '/docs/.*.pdf$', '^Report.*.pdf$']

      - `IReadOnlyList<string>? RequiredExts`

        The list of required file extensions.

      - `string? SiteID`

        The ID of the SharePoint site to download from.

      - `string? SiteName`

        The name of the SharePoint site to download from.

      - `SupportsAccessControl SupportsAccessControl`

        - `trueTrue`

    - `class CloudSlackDataSource:`

      - `required string SlackToken`

        Slack Bot Token.

      - `string? ChannelIds`

        Slack Channel.

      - `string? ChannelPatterns`

        Slack Channel name pattern.

      - `string ClassName`

      - `string? EarliestDate`

        Earliest date.

      - `Double? EarliestDateTimestamp`

        Earliest date timestamp.

      - `string? LatestDate`

        Latest date.

      - `Double? LatestDateTimestamp`

        Latest date timestamp.

      - `Boolean SupportsAccessControl`

    - `class CloudNotionPageDataSource:`

      - `required string IntegrationToken`

        The integration token to use for authentication.

      - `string ClassName`

      - `string? DatabaseIds`

        The Notion Database Id to read content from.

      - `string? PageIds`

        The Page ID's of the Notion to read from.

      - `Boolean SupportsAccessControl`

    - `class CloudConfluenceDataSource:`

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Confluence APIs.

      - `required string ServerUrl`

        The server URL of the Confluence instance.

      - `string? ApiToken`

        The API token to use for authentication.

      - `string ClassName`

      - `string? Cql`

        The CQL query to use for fetching pages.

      - `FailureHandlingConfig FailureHandling`

        Configuration for handling failures during processing. Key-value object controlling failure handling behaviors.

        Example:
        {
        "skip_list_failures": true
        }

        Currently supports:

        - skip_list_failures: Skip failed batches/lists and continue processing

        - `Boolean SkipListFailures`

          Whether to skip failed batches/lists and continue processing

      - `Boolean IndexRestrictedPages`

        Whether to index restricted pages.

      - `Boolean KeepMarkdownFormat`

        Whether to keep the markdown format.

      - `string? Label`

        The label to use for fetching pages.

      - `string? PageIds`

        The page IDs of the Confluence to read from.

      - `string? SpaceKey`

        The space key to read from.

      - `Boolean SupportsAccessControl`

      - `Boolean SyncPermissions`

        Whether to fetch space-level permissions (allowed users/groups) and attach them to document metadata for access control. Disable for Confluence Server/Data Center versions whose permission APIs are unavailable (e.g. the JSON-RPC API removed in Data Center 9.2.6+), which otherwise surface as 401 errors during sync.

      - `string? UserName`

        The username to use for authentication.

    - `class CloudJiraDataSource:`

      Cloud Jira Data Source integrating JiraReader.

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Jira APIs.

      - `required string Query`

        JQL (Jira Query Language) query to search.

      - `string? ApiToken`

        The API/ Access Token used for Basic, PAT and OAuth2 authentication.

      - `string ClassName`

      - `string? CloudID`

        The cloud ID, used in case of OAuth2.

      - `string? Email`

        The email address to use for authentication.

      - `string? ServerUrl`

        The server url for Jira Cloud.

      - `Boolean SupportsAccessControl`

    - `class CloudJiraDataSourceV2:`

      Cloud Jira Data Source integrating JiraReaderV2.

      - `required string AuthenticationMechanism`

        Type of Authentication for connecting to Jira APIs.

      - `required string Query`

        JQL (Jira Query Language) query to search.

      - `required string ServerUrl`

        The server url for Jira Cloud.

      - `string? ApiToken`

        The API Access Token used for Basic, PAT and OAuth2 authentication.

      - `ApiVersion ApiVersion`

        Jira REST API version to use (2 or 3). 3 supports Atlassian Document Format (ADF).

        - `"2"2`

        - `"3"3`

      - `string ClassName`

      - `string? CloudID`

        The cloud ID, used in case of OAuth2.

      - `string? Email`

        The email address to use for authentication.

      - `string? Expand`

        Fields to expand in the response.

      - `IReadOnlyList<string>? Fields`

        List of fields to retrieve from Jira. If None, retrieves all fields.

      - `Boolean GetPermissions`

        Whether to fetch project role permissions and issue-level security

      - `Long? RequestsPerMinute`

        Rate limit for Jira API requests per minute.

      - `Boolean SupportsAccessControl`

    - `class CloudBoxDataSource:`

      - `required AuthenticationMechanism AuthenticationMechanism`

        The type of authentication to use (Developer Token or CCG)

        - `"ccg"Ccg`

        - `"developer_token"DeveloperToken`

      - `string ClassName`

      - `string? ClientID`

        Box API key used for identifying the application the user is authenticating with

      - `string? ClientSecret`

        Box API secret used for making auth requests.

      - `string? DeveloperToken`

        Developer token for authentication if authentication_mechanism is 'developer_token'.

      - `string? EnterpriseID`

        Box Enterprise ID, if provided authenticates as service.

      - `string? FolderID`

        The ID of the Box folder to read from.

      - `Boolean SupportsAccessControl`

      - `string? UserID`

        Box User ID, if provided authenticates as user.

  - `required string DataSourceID`

    The ID of the data source.

  - `required DateTimeOffset LastSyncedAt`

    The last time the data source was automatically synced.

  - `required string Name`

    The name of the data source.

  - `required string PipelineID`

    The ID of the pipeline.

  - `required string ProjectID`

  - `required SourceType SourceType`

    - `"AZURE_STORAGE_BLOB"AzureStorageBlob`

    - `"BOX"Box`

    - `"CONFLUENCE"Confluence`

    - `"GOOGLE_DRIVE"GoogleDrive`

    - `"JIRA"Jira`

    - `"JIRA_V2"JiraV2`

    - `"MICROSOFT_ONEDRIVE"MicrosoftOnedrive`

    - `"MICROSOFT_SHAREPOINT"MicrosoftSharepoint`

    - `"NOTION_PAGE"NotionPage`

    - `"S3"S3`

    - `"SLACK"Slack`

  - `DateTimeOffset? CreatedAt`

    Creation datetime

  - `IReadOnlyDictionary<string, CustomMetadata?>? CustomMetadata`

    Custom metadata that will be present on all data loaded from the data source

    - `IReadOnlyDictionary<string, JsonElement>`

    - `IReadOnlyList<JsonElement>`

    - `string`

    - `Double`

    - `Boolean`

  - `Status? Status`

    The status of the data source in the pipeline.

    - `"CANCELLED"Cancelled`

    - `"ERROR"Error`

    - `"IN_PROGRESS"InProgress`

    - `"NOT_STARTED"NotStarted`

    - `"SUCCESS"Success`

  - `DateTimeOffset? StatusUpdatedAt`

    The last time the status was updated.

  - `Double? SyncInterval`

    The interval at which the data source should be synced.

  - `string? SyncScheduleSetBy`

    The id of the user who set the sync schedule.

  - `DateTimeOffset? UpdatedAt`

    Update datetime

  - `DataSourceReaderVersionMetadata? VersionMetadata`

    Version metadata for the data source

    - `ReaderVersion? ReaderVersion`

      The version of the reader to use for this data source.

      - `"1.0"1_0`

      - `"2.0"2_0`

      - `"2.1"2_1`
